XdkWrl: PlaneSensor Class Reference

Home | Hierarchy | Members | Alphabetical | Related Pages

# PlaneSensor Class Reference
[Standard Node Types]

`#include <planesensor.h>`

Inherits Node.

List of all members.

## Public Member Functions
| PlaneSensor (const char *name="")
virtual | ~PlaneSensor ()
virtual unsigned int | nbFields () const
virtual FieldHandle | field (const std::string &n)
virtual FieldHandle | field (unsigned int i)
virtual bool | isSetToDefaultValue (unsigned int i) const
virtual unsigned int | nbEventsIn () const
virtual EventInHandle | eventIn (const std::string &n)
virtual EventInHandle | eventIn (unsigned int i)
virtual unsigned int | nbEventsOut () const
virtual EventOutHandle | eventOut (const std::string &n)
virtual EventOutHandle | eventOut (unsigned int i)
const char * | typeName () const
virtual Node * | duplicate () const
virtual Node * | duplicate (std::map< const Node *, Node * > &) const
## Public Attributes
Exposed Fields
A field that is capable of receiving events via an eventIn to change its value(s), and generating events via an eventOut when its value(s) change.
SFBool | autoOffset
SFBool | enabled
SFVec2f | maxPosition
SFVec2f | minPosition
SFVec3f | offset
Events In
EventIn< SFBool > | set_autoOffset
EventIn< SFBool > | set_enabled
EventIn< SFVec2f > | set_maxPosition
EventIn< SFVec2f > | set_minPosition
EventIn< SFVec3f > | set_offset
Events Out
EventOut< SFBool > | isActive
EventOut< SFVec3f > | trackPoint_changed
EventOut< SFVec3f > | translation_changed
EventOut< SFBool > | autoOffset_changed
EventOut< SFBool > | enabled_changed
EventOut< SFVec2f > | maxPosition_changed
EventOut< SFVec2f > | minPosition_changed
EventOut< SFVec3f > | offset_changed

## Detailed Description

Here is the documentation for this node type, from the ISO standard.

## 6.52 PlaneSensor

The PlaneSensor node maps pointing device motion into two-dimensional translation in a plane parallel to the Z=0 plane of the local coordinate system. The PlaneSensor node uses the descendent geometry of its parent node to determine whether it is liable to generate events.

The enabled exposedField enables and disables the PlaneSensor. If enabled is TRUE, the sensor reacts appropriately to user events. If enabled is FALSE, the sensor does not track user input or send events. If enabled receives a FALSE event and isActive is TRUE, the sensor becomes disabled and deactivated, and outputs an isActive FALSE event. If enabled receives a TRUE event, the sensor is enabled and made ready for user activation.

The PlaneSensor node generates events when the pointing device is activated while the pointer is indicating any descendent geometry nodes of the sensor's parent group. See 4.6.7.5, Activating and manipulating sensors, for details on using the pointing device to activate the PlaneSensor.

Upon activation of the pointing device (e.g., mouse button down) while indicating the sensor's geometry, an isActive TRUE event is sent. Pointer motion is mapped into relative translation in the tracking plane, (a plane parallel to the sensor's local Z=0 plane and coincident with the initial point of intersection). For each subsequent movement of the bearing, a translation_changed event is output which corresponds to the sum of the relative translation from the original intersection point to the intersection point of the new bearing in the plane plus the offset value. The sign of the translation is defined by the Z=0 plane of the sensor's coordinate system. trackPoint_changed events reflect the unclamped drag position on the surface of this plane. When the pointing device is deactivated and autoOffset is TRUE, offset is set to the last translation_changed value and an offset_changed event is generated. More details are provided in 4.6.7.4, Drag sensors.

When the sensor generates an isActive TRUE event, it grabs all further motion events from the pointing device until it is deactivated and generates an isActive FALSE event. Other pointing-device sensors shall not generate events during this time. Motion of the pointing device while isActive is TRUE is referred to as a "drag." If a 2D pointing device is in use, isActive events typically reflect the state of the primary button associated with the device (i.e., isActive is TRUE when the primary button is pressed, and is FALSE when it is released). If a 3D pointing device (e.g., wand) is in use, isActive events typically reflect whether the pointer is within or in contact with the sensor's geometry.

minPosition and maxPosition may be set to clamp translation_changed events to a range of values as measured from the origin of the Z=0 plane. If the X or Y component of minPosition is greater than the corresponding component of maxPosition, translation_changed events are not clamped in that dimension. If the X or Y component of minPosition is equal to the corresponding component of maxPosition, that component is constrained to the given value. This technique provides a way to implement a line sensor that maps dragging motion into a translation in one dimension.

While the pointing device is activated and moved, trackPoint_changed and translation_changed events are sent. trackPoint_changed events represent the unclamped intersection points on the surface of the tracking plane. If the pointing device is dragged off of the tracking plane while activated (e.g., above horizon line), browsers may interpret this in a variety ways (e.g., clamp all values to the horizon). Each movement of the pointing device, while isActive is TRUE, generates trackPoint_changed and translation_changed events.

Further information about this behaviour can be found in 4.6.7.3, Pointing-device sensors, 4.6.7.4, Drag sensors, and 4.6.7.5, Activating and manipulating sensors.

## Constructor & Destructor Documentation

PlaneSensor | ( | const char * | name = `""` | ) |

Construct a node with all its fields set to default value, which is equivalent to the code below:

      autoOffset = true;
      enabled = true;
      maxPosition.setXY(-1,-1);
      minPosition.setXY(0,0);
      offset.setXYZ(0,0,0);

~PlaneSensor | ( |  | ) | `[virtual]`

Virtual destructor, does nothing

## Member Function Documentation

unsigned int nbFields | ( |  | ) | const`[inline, virtual]`

Returns the number of fields (exposed or not) for this node type.

Implements Node.

wrl::Node::FieldHandle field | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the field named `n` of the node or a "unknown" typed handle if there is no such field. Valid names are:

- autoOffset
- enabled
- maxPosition
- minPosition
- offset

Implements Node.

wrl::Node::FieldHandle field | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th field of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : autoOffset
- 1 : enabled
- 2 : maxPosition
- 3 : minPosition
- 4 : offset This function is useful, with nbFields() if you want to traverse all fields of a Node.

Implements Node.

bool isSetToDefaultValue | ( | unsigned int | i | ) | const`[virtual]`

Implements Node.

unsigned int nbEventsIn | ( |  | ) | const`[inline, virtual]`

Returns the number of events in for this node type.

Implements Node.

wrl::Node::EventInHandle eventIn | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the event in named `n` of the node or a "unknown" typed handle if there is no such event. Valid names are:

- set_autoOffset
- set_enabled
- set_maxPosition
- set_minPosition
- set_offset

Implements Node.

wrl::Node::EventInHandle eventIn | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th event in of the node or a "unknown" typed handle if there is no such node. emarks This class has no eventIn. This function is useful, with nbEventsIn() if you want to traverse all events in of a Node.

Implements Node.

unsigned int nbEventsOut | ( |  | ) | const`[inline, virtual]`

Returns the number of events out for this node type.

Implements Node.

wrl::Node::EventOutHandle eventOut | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the event out named `n` of the node or a "unknown" typed handle if there is no such event. Valid names are:

- isActive
- trackPoint_changed
- translation_changed
- autoOffset_changed
- enabled_changed
- maxPosition_changed
- minPosition_changed
- offset_changed

Implements Node.

wrl::Node::EventOutHandle eventOut | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th event out of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : isActive
- 1 : trackPoint_changed
- 2 : translation_changed
- 3 : autoOffset_changed
- 4 : enabled_changed
- 5 : maxPosition_changed
- 6 : minPosition_changed
- 7 : offset_changed This function is useful, with nbEventsOut() if you want to traverse all events in of a Node.

Implements Node.

const char * typeName | ( |  | ) | const`[inline, virtual]`

Returns `"PlaneSensor"`. Useful for printing.

Implements Node.

wrl::Node * duplicate | ( |  | ) | const`[virtual]`

Returns a deep copy of this node, that is a fully independant node with all children (if any) also copied. This is mainly useful for instanciating protos.

Implements Node.

virtual Node* duplicate | ( | std::map< const Node *, Node * > & |  | ) | const`[virtual]`

Implements Node.

## Member Data Documentation

SFBool autoOffset

See Detailed Description for meaning of this field. Default value is set to

           autoOffset = true;

SFBool enabled

See Detailed Description for meaning of this field. Default value is set to

           enabled = true;

SFVec2f maxPosition

See Detailed Description for meaning of this field. Default value is set to

           maxPosition.setXY(-1,-1);

SFVec2f minPosition

See Detailed Description for meaning of this field. Default value is set to

           minPosition.setXY(0,0);

SFVec3f offset

See Detailed Description for meaning of this field. Default value is set to

           offset.setXYZ(0,0,0);

EventIn<SFBool> set_autoOffset

Set event associated to exposedField autoOffset

EventIn<SFBool> set_enabled

Set event associated to exposedField enabled

EventIn<SFVec2f> set_maxPosition

Set event associated to exposedField maxPosition

EventIn<SFVec2f> set_minPosition

Set event associated to exposedField minPosition

EventIn<SFVec3f> set_offset

Set event associated to exposedField offset

EventOut<SFBool> isActive

See Detailed Description for meaning of this event.

EventOut<SFVec3f> trackPoint_changed

See Detailed Description for meaning of this event.

EventOut<SFVec3f> translation_changed

See Detailed Description for meaning of this event.

EventOut<SFBool> autoOffset_changed

Changed event associated to exposedField autoOffset

EventOut<SFBool> enabled_changed

Changed event associated to exposedField enabled

EventOut<SFVec2f> maxPosition_changed

Changed event associated to exposedField maxPosition

EventOut<SFVec2f> minPosition_changed

Changed event associated to exposedField minPosition

EventOut<SFVec3f> offset_changed

Changed event associated to exposedField offset

Generated on 5 Jan 2007 with version 1.5.1. |